%%% -*- Module: fsa_cpp; -*-
:- module(fsa_cpp,
	  [ fsa_cpp/2,
	    fsa_cpp_fa/2
	  ]).

#swi# :- style_check([-atom]).

:- multifile user:help_info/4.
:- discontiguous user:help_info/4.

:- discontiguous help_info/4.


user:help_info(class,fsa_cpp,"C++ Code Generation","
FSA supports the production of C++ code on the basis of
a finite automaton.  Before the automaton is translated into C++ code, 
it is determinized. In the case of transducers, Mohri's determinization
algorithm is applied. Note however that certain transductions cannot be
determinized: in that case the algorithm will not terminate. 

Further documentation: refer to the fsa_fl module.
").


user:help_info(xpred,fsa_cpp,
"fsa_cpp(+FileIn,+FileOut)","
A C++ program is written to FileOut for the recognizer read
from FileIn. The C++ program will read lines from standard input
and apply the automaton to each line. ").

fsa_cpp(Source,Target):-
    fsa_fl:fsa_fl_file(cpp,Source,Target).

fsa_cpp_fa(Fa,Target):-
    fsa_fl:fsa_fl_fa(cpp,Fa,Target).
