:- module(fsa_strings,[]).

#swi# :- style_check([-atom]).

#sic# :- use_module(library(lists), [ append/3 ]).
#yap# :- use_module(library(lists), [ append/3 ]).

%%%%%%%%%%%%%
%% strings %%
%%%%%%%%%%%%%

:- public zero/1, fsa_plus/3, minus/3, minimum/3, minimum_only/1.

zero([]).		% identity element for 'plus'.

fsa_plus(A,B,C) :-
    append(A,B,C).

minus(A,B,C) :-
    append(B,C,A).

%% now: also ignores '$@dequeue'
minimum(A,B,C) :-
    longest_common_prefix(A,B,C).

% %% "cheapest = shortest"
% minimal_path_minimum(A,B,C) :-
%     length(A,Al),
%     length(B,Bl),
%     (   Al =< Bl
%     ->  C=A
%     ;   C=B
%     ).

longest_common_prefix([],_,[]).
longest_common_prefix([H|T],L2,L):-
    longest_common_prefix0(L2,H,T,L).

longest_common_prefix0([],_,_,[]).
longest_common_prefix0([H2|T2],H1,T1,L):-
    (	H2 == H1
    ->  L = [H2|T],
	longest_common_prefix(T1,T2,T)
    ;	L=[]
    ).

minimum_only(no).

