:- module(fsa_weighted_strings,[]).

#swi# :- style_check([-atom]).

#sic# :- use_module(library(lists), [ append/3 ]).
#yap# :- use_module(library(lists), [ append/3 ]).

:- public zero/1, fsa_plus/3, minus/3, minimum/3, minimum_only/1.

%%%%%%%%%%%%%%%%%%%%%%
%% weighted strings %%
%%%%%%%%%%%%%%%%%%%%%%

zero([]/0).		% identity element for 'plus'.

fsa_plus(W0/Score0,W1/Score1,W/Score) :-
    Score is Score0+Score1,
    append(W0,W1,W).

minus(W0/Score0,W1/Score1,W/Score) :-
    Score is Score0-Score1,
    append(W1,W,W0).


minimum(W0/Score0,W1/Score1,W/Score) :-
    Score is min(Score0,Score1),
    fsa_strings:longest_common_prefix(W0,W1,W).

% %% suggested by Ken Shan, ken@digitas.harvard.edu
% minimal_path_minimum(W0/Score0,W1/Score1,W/Score) :-
%     (	Score0 =< Score1
%     ->	W0=W, Score0=Score
%     ;	W1=W, Score1=Score
%     ).

minimum_only(no).

