:- module(fsa_weights,[]).

#swi# :- style_check([-atom]).

:- public zero/1, fsa_plus/3, minus/3, minimum/3, minimal_path_minimum/3, minimum_only/1.

%%%%%%%%%%%%%
%% weights %%
%%%%%%%%%%%%%

%% string-to-weight transducers, i.e.
%% weighted recognizers.

zero(0).

fsa_plus(Score0,Score1,Score) :-
    Score is Score0+Score1.

minus(Score0,Score1,Score) :-
    Score is Score0-Score1.

minimum(Score0,Score1,Score) :-
    Score is min(Score0,Score1).

minimal_path_minimum(Score0,Score1,Score) :-
    Score is min(Score0,Score1).

minimum_only(Flag) :-
    fsa_globals:fsa_global_get(w_determinizer_minimum,OnOff),
    (	OnOff == on
    ->	Flag=yes
    ;	Flag=no
    ).

